module ProjectEuler.Problem2 (problem2) where

--Even Fibonacci numbers
--
--Each new term in the Fibonacci sequence is generated by adding the previous two terms. By starting with 1 and 2, the first 10 terms will be:
--
--1, 2, 3, 5, 8, 13, 21, 34, 55, 89, ...
--
--By considering the terms in the Fibonacci sequence whose values do not exceed four million, find the sum of the even-valued terms.

import Math.Sets
import ProjectEuler.Utils

number = 2

title = "Even Fibonacci numbers"

description = "Each new term in the Fibonacci sequence is generated by adding the previous two terms. By starting with 1 and 2, the first 10 terms will be: \n\n\
              \1, 2, 3, 5, 8, 13, 21, 34, 55, 89, ...\n\n\
              \By considering the terms in the Fibonacci sequence whose values do not exceed four million, find the sum of the even-valued terms."

solution = sum . filter even . takeWhile (<4000000) $ fibonacci

problem2 = Problem number title description solution
